<template>
  <v-row align="center" justify="center">
    <v-col cols="12" sm="8" md="8">
      <form class="form" @submit.prevent="submit">
        <!-- Form Template -->
        <template v-for="(field, key) in formFields">
          <field-group :field-id="key" :key="`${_uid}-${field.name}`">
            <div class="form__header" v-show="key === 0">
              <h1>{{ attrs.title }}</h1>
            </div>
            <v-card class="form__field-area">
              <field-label :for="`${_uid}-${field.name}`">
                {{ key + 1 }}. {{ field.label }}
              </field-label>
              <p v-if="field.text" class="form__text">
                {{ field.text }}
              </p>
              <Component
                v-model="formData[field.name]"
                :is="field.component"
                v-bind="{ ...field.options.attrs }"
                :id="`${_uid}-${field.name}`"
                :name="`${field.name}`"
                :type="field.type"
                @input="
                  updateField({
                    key: field.name,
                    value: formData[field.name],
                    label: field.label,
                  })
                "
                v-validate="field.validation"
                :data-vv-as="field.label"
                :options="
                  !!field.options.choices ? field.options.choices : false
                "
                :multiple-opt="field.multiple"
                :autocomplete-opt="field.autocomplete"
              />
            </v-card>
            <!-- Next and Back Nav -->
            <form-nav
              :key="`nav-${field.name}`"
              :field-id="key"
              @back="back"
              @next="next"
            />
          </field-group>
        </template>

        <!-- Form Results -->
        <form-result @back="back" />
      </form>
    </v-col>
    <form-progress />
  </v-row>
</template>

<script>
import FieldGroup from "./form-elements/FieldGroup.vue";
import FieldLabel from "./form-elements/FieldLabel.vue";

import FormNav from "./form-elements/FormNav.vue";
import FormProgress from "./form-elements/FormProgress.vue";
import FormResult from "./form-elements/FormResult.vue";

import formMixin from "./mixins/formMixin";
// import { mapMutations } from 'vuex'

import DtService from "@/services/dtService";

export default {
  name: "DtiFormTemplate",
  mixins: [formMixin],
  props: {
    formFields: {
      type: Array,
      default: () => [],
    },
    attrs: {
      type: Object,
      required: true,
    },
  },
  components: {
    FieldGroup,
    FieldLabel,
    FormNav,
    FormResult,
    FormProgress,
  },
  provide() {
    return {
      formState: this.formState,
    };
  },
  mounted() {
    this.$store.dispatch("typeform/resetFormData");
  },
  methods: {
    updateField(data) {
      this.$store.dispatch("typeform/updateField", data);
    },

    submit() {
      DtService.postAnswers()
        .then(() => this.$router.push({ name: "home" }))
        .catch((err) => {
          this.$log.error(err);
        });
    },
  },
};
</script>
